# Supplied Archive #

The code of the implementation is supplied in an archive with this thesis. Only the most relevant code is supplied in this appendix. Note that in order to run most of the software, appropriate hardware must be used, available from the Orbit satellite group.

The archived code must be considered a frozen image of an on-going development effort. For anything other than historical references, the current software repositories are recommended: https://git.erlendjs.no/erlends-os for the operating system itself and https://git.orbitntnu.no/orbit for the satellite. **The archived code supplied with this thesis should not be used and redistributed, the repositories linked above should be used instead.** This is because it is guaranteed to be outdated. Some software components are omitted from the archive, that are not relevant to the understanding of this thesis.

## Supplied Archive Structure ##

The supplied archive contains a partial frozen version of the main repository used for the Orbit satellite group. The most important parts can be found in these locations:

 *  `/README.md`
    A copy of the text found here, written in markdown.
 *  `/orbit-main-repository/README.md`
    The main readme for the satellite group. It contains a quick start guide on how to download, compile, run and use the operating system and the programs that run on it. The "live" version of this readme can be found at https://git.orbitntnu.no/orbit/orbit, which should be your main entry point to the project.
 *  `/orbit-main-repository/bin`
    This directory contains extremely simple versions of your typical UNIX core utilities, such as the file copy program _cp_ and a shell _sh_. These are all regular programs that make full use of the solutions presented in this thesis, and most can be used as code examples.
 *  `/orbit-main-repository/docs`
    Contains the wiki pages that adds to the main repository readme. It describes various subjects in greater detail.
 *  `/orbit-main-repository/kernel/kernel`
    This is the kernel repository. All the code for the solutions presented in this thesis can be found here. Headers are located in _inc_ and sources are located in _src_. The directory naming should be mostly self explanatory, however, you may find the most relevant parts of the thesis in the following locations: memory allocation in _mem_ and _mpu_, process loading in _process_ and _elf_, and at last paging in _mpu/pager.c_.
 *  `/orbit-main-repository/kmod`
    Kernel modules are kept here. At the moment there is only one, the _fatfs_ file system module, which is the only third party developed part of the kernel. Note that the code of the file system itself is not supplied in this archive, and must be supplied separately.
 *  `/orbit-main-repository/lib`
    This directory contains libraries. The most important is the _libcglue_ library, which is the standard C library. More libraries can be found at git.erlendjs.no and git.orbitntnu.no.
 *  `/orbit-main-repository/programs`
    This directory contains user programs specifically written for the satellite. Since these are not really related to the thesis and contains second and third party code, only the test programs are supplied. Visit git.orbitntnu.no for the actual satellite programs.
 *  `/orbit-main-repository/usr`
    Contains all other programs that are not important core utilities. Similar to the other directories, this also only contains the most important ones. The full collection of 24 (at the time of writing) user programs can be found at git.erlendjs.no.
 *  `/orbit-main-repository/util`
    This directory contains some generalized development utilities, such as parts of the build system, file transfer programs and repository management.

## Code Licensing ##

The kernel is licensed under the GNU General Public Licence (GPL) Version 3. See the licence in the _/orbit-main-repository/kernel/kernel/copying_ file for more details.

Other programs are mostly licensed under the BSD license, while some are under GPL. See their appropriate directories and files for more information.
