# Creating a User #

Go to [Orbit's GitLab](https://git.orbitntnu.no) and register a new user, using your student email address for example. Every code repository specific to Orbit operations will be hosted at this server. We recommend using a new unique password for your account.

# SSH #

Only registered users will have write access to the repositories. To clone the repositories, your PC needs to be authenticated with your user. This is done using an SSH key pair. One part is called the public key and the other part is called the private key. The public key must be added to your user at GitLab while the private key must be kept secret on your computer.

## Generating an SSH key pair on Linux ##

To generate a key pair, use the tool `ssh-keygen`. Open a terminal, and navigate to the `.ssh` folder in your home directory:

```bash
cd ~/.ssh
ssh-keygen
```

It will ask for a filename and passphrase. The filename can be OrbitGitLabKey for example. The passphrase can be empty if you like. Note that with no password/passphrase specified you will be able to use git without typing the password for every pull/push command, however, security is now reliant on the secrecy of the private key file itself, so you must be careful. You will now have two files. OrbitGitLabKey, which is your private key and OrbitGitLabKey.pub, which is the corresponding public key.

Still in the `~/.ssh/` folder, create a text file called `config`, enter the following
```
Host git.orbitntnu.no
	HostName git.orbitntnu.no
	User git
	IdentityFile ~/.ssh/orbitGitLabKey
```
and save.

## Adding the key to your Orbit NTNU Gitlab Account ##

On [Orbit's GitLab](https://git.orbitntnu.no), got to your user settings. Then, to the left, find the field "SSH Keys" and click on it. Copy all contents of the public key file and paste it into the large textbox. Give your key a fitting name like OrbitKeyOnLaptop and click 'Add Key'. Now if you enter

```bash
ssh git.orbitntnu.no
```

in a terminal, it should print out among other stuff 

```bash
Welcome to GitLab, @yourGitLabUsername!
```

and you should be able to pull the orbit repository with

```bash
git clone --recurse-submodules git@git.orbitntnu.no:orbit/orbit.git
```


