This is the main repository wiki. It is intended to contain general information regarding the Orbit projects such as getting started guides, repository management rules etc.

Important information:

 *  Before you can download the code you must have a user at our GitLab instance
    and SSH correctly set up. When you are able to run `ssh git.orbitntnu.no` and
    be greeted with your username, you know it works. See
    the [wiki page](https://git.orbitntnu.no/orbit/orbit/wikis/User-creation-and-SSH) for details.
 *  For instructions on how to download and install the repositories and
    required tools as quickly as possible, read the
    [short installation guide](https://git.orbitntnu.no/orbit/orbit/blob/master/README.md#installing-short-version).
    It will guide you
    through installing the tools, downloading the code, building it and running
    the hello world program on an actual OBC board. At this point you're all set
    for writing programs, but you should really read on to get a better understanding
    of our ecosystem and how we do things.
 *  Further information about cloning and building can be found at the
    [Cloning](https://git.orbitntnu.no/orbit/orbit/wikis/cloning)
    and [Building](https://git.orbitntnu.no/orbit/orbit/wikis/building) pages respectively.
 *  Further information about our use of git submodules can be found at
    [this page](https://git.orbitntnu.no/orbit/orbit/wikis/submodules). You should
    read this page prior to making any new repositiories, to keep things consistent.
 *  For further information on how to manage repositories, code, ownership,
    licencing etc., see the (TBA).
 *  Individual modules/projects/programs usually have their own documentation,
    check the appropriate repositories for those.
 *  The kernel is documented [in its own wiki](https://git.erlendjs.no/erlends-os/kernel/kernel/wikis/home).
    Information about APIs and core utilities can be found there. If you find
    redundant information regarding repository management, core rules etc. there
    keep in mind that those are intended for kernel development and not necessary
    the Orbit specific software projects.
 *  The programs that you are likely to work on are in the `programs` directory
    which are specific to Orbit operations. Core utilities are found in `bin` and
    miscellaneous programs are located in `usr`. These folders contain programs
    that are to be uploaded and run on the OBC. The `kernel` and `kmod` folders
    contain the kernel itself and kernel modules, which are flashed into the
    microcontroller itself and not the filesystem. Offline documentation is located
    in `docs` and tools are found in `util`.

## Troubleshooting ##

 1. When cloning the orbit repository, some submodules are successfully downloaded and some are not.

    Make sure you connect to the internet via eduroam and not via ntnuguest, since ntnuguest is limiting the number of ssh connections you can make. If you are still experiencing errors, check that you are able to [ssh to the server outside of git](https://git.orbitntnu.no/orbit/orbit/wikis/User-creation-and-SSH#adding-the-key-to-your-orbit-ntnu-gitlab-account).