# TODO #

## Kernel ##

Solved:
 * (OK) TMS570: Add CAN driver
 * (OK) TMS570: Fix the nanosleep bug (unable to reproduce)
 * (OK) TMS570: Fix Ctrl^C not working
 * (OK) TMS570: Fix random crashes, most notably appearing in kernel timer
 * (OK) TMS570: Add the rest of the SPI CS pins
 * (OK) TMS570: Add PWM output driver
 * (OK) General: Support some kind of uname (solved by sys version)
 * (OK) General: Broken piping with the shell (appears solved, cant reproduce)
 * (OK) ENET: Receive buffer size and efficiency
 * (OK) ENET: Check receive size in tun-enet
 * (OK) ENET: Check for routing loops in tun-enet
 * (OK) ENET: Check tun-enet speed (try more than 115200) (500K works)
 * (OK) ENET: Check behaviour when sending packets that are too large (return EMSGSIZE)
 * (OK) ENET: Incorrect number of bytes reported as sent
 * (OK) ENET: Fifo instead of Lifo

Normal priority:
 * TMS570: Add analogue input driver
 * TMS570: Support more safety features
 * TMS570: Power saving, tickless idle.
 * STM32: Network bugs. In particular the deadlock (router error?) and then checksums
 * MemAlloc: New superblocks
 * MemAlloc: Bank types instead of priority
 * General: SD Card driver for SPI mode
 * General: A process can terminate while a child is in the blocked state, causing
    the worker thread to try waking a zombied process.
 * General: System call pointer verification
 * ENET: Data loss in ttyserv program
 * ENET: Enable checksums in all nodes
 * UNIX Domain: Local sockets (UNIX Domain Sockets, may replace pipes with this)

Low priority:
 * TMS570: SPI Locking (currently implicit by driver not allowing sharing)
 * General: Config cleanup, make certain that all of them will build
 * General: Build automation with gitlab, checking all configurations
 * General: Loadable kernel modules (a kind of dynamic loading)
 * General: User mode dynamic loading
 * ENET: Transmit buffer size in the driver interface

## sh ##

 * (OK) "cd" crashes the shell (probably expects argument)

## sleep ##

 * (OK) Sleeps for seconds instead of milliseconds (actually this is correct, the help text of the program is just wrong)

## mv ##

 * mv is broken, does nothing and returns no error

## errno ##

 * (OK) "ls asdf" causes "Address family not supported" message
 * (OK) Load error is not shown

## sys ##

 * (OK) Reboot option. Cleanest way to implement is manually triggering a watchdog timer.
