/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

// Need this when using GPIO
#include "drivers/gpio/gpio-stm32f407.h"

// Set default LCD orientation (1) horizontal (0) vertical
#define LCD_DEFAULT_ORIENTATION 1

// Set LCD type
#define LCD_TYPE LCD_ILI9488

// Set LCD access registers
#define LCD_DATA_PORT GPIOB
#define LCD_CTRL_PORT GPIOC
#define LCD_RD_PIN PIN(3)
#define LCD_WR_PIN PIN(2)
#define LCD_RS_PIN PIN(1)

// Access are functions for this driver
void LCD_COMMAND (int cmd);
void LCD_DATA (int data);
void LCD_DATA_16 (int data);

// Dimensions when in horizontal
#define LCD_WIDTH 480
#define LCD_HEIGHT 320
