/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

///////////////////////////////////////////////////////////////////////////////
// Memory init options
///////////////////////////////////////////////////////////////////////////////
#define PLATFORM_USE_LCD 0
#define PLATFORM_USE_INTERNAL_MEMORY 0
#define PLATFORM_USE_EXTERNAL_MEMORY 1
#define PLATFORM_EXTERNAL_MEMORY_ADDR 0xD0000000
#define PLATFORM_EXTERNAL_MEMORY_SIZE (8 * 1024 * 1024)

///////////////////////////////////////////////////////////////////////////////
// Platform FSMC config
///////////////////////////////////////////////////////////////////////////////

// Platform FSMC config
#define PLATFORM_LCD_FSMC 0

// FMC SDNWE
#define PLATFORM_FSMC_PINS_PORTC (PIN(0))

// FMC D0 - D3, D13 - D15
#define PLATFORM_FSMC_PINS_PORTD (PIN(0) | PIN(1) | \
	PIN(8) | PIN(9) | PIN(10) | PIN(14) | PIN(15))

// FMC NBL0, NBL1, D4 - D12
#define PLATFORM_FSMC_PINS_PORTE (PIN(0) | PIN(1) | \
	PIN(7) | PIN(8) | PIN(9) | PIN(10) | \
	PIN(11) | PIN(12) | PIN(13) | PIN(14) | PIN(15))

// A0 - A9, SDNRAS
#define PLATFORM_FSMC_PINS_PORTF (PIN(0) | PIN(1) | \
	PIN(2) | PIN(3) | PIN(4) | PIN(5) | \
	PIN(12) | PIN(13) | PIN(14) | PIN(15) |\
	PIN(11))

// A10 - A11, BA0, BA1, SDCLK, SDNCAS
#define PLATFORM_FSMC_PINS_PORTG (PIN(0) | PIN(1) | PIN(4) | PIN(5) | PIN(8) |\
	PIN(15))

// SDNE1, SDCKE1
#define PLATFORM_FSMC_PINS_PORTH (PIN(6) | PIN(7))

///////////////////////////////////////////////////////////////////////////////
// HSE Clock Frequency
///////////////////////////////////////////////////////////////////////////////
#define HSE_CLK_FREQ 25000000

///////////////////////////////////////////////////////////////////////////////
// PLL Initial Configuration
///////////////////////////////////////////////////////////////////////////////
#define PLL_M 25
#define PLL_N 336
#define PLL_P 0 // Check datasheet! 0 = DIV/2
#define PLL_SRC 1
#define PLL_Q 7
