/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

// Maximum number of nodes in the node table
#define NODETABLE_SIZE 16

// Maximum number of virtual file systems
#define VFS_MAX_DRIVERS 4

// Maximum path size
#define VFS_MAX_PATH 64

// Maximum mount point name/path size
#define VFS_MOUNTPOINT_MAX_SIZE 16

// Maximum mount point prepend size
#define VFS_PREPEND_MAX_SIZE 4

// Maximum number of file descriptors per process
#define MAX_NODES 8

// Specifies if the stdin/stdout is to be reopened in init and the filename
#define INIT_REOPENSTDIO 0
#define INIT_REOPEN_FILENAME "/dev/fbcon"

// Enables (1) or disables (0) the two different panic solutions
// Both may be enabled at the same time
#define PANIC_ENABLE_TTY 1
#define PANIC_ENABLE_LCD 0

// Run a custom "main" instead of launching the root shell, for use in
// minimal configurations
#define INIT_CUSTOM_MINIMAL_MAIN 0

// The default tty for kernel messages and user terminal
#define INIT_DEFAULT_TTY "/dev/tty1"
