/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

///////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////
#include "arch/stm32/rcc.h"

///////////////////////////////////////////////////////////////////////////////
// Structures
///////////////////////////////////////////////////////////////////////////////
typedef struct _RCC
{
	volatile unsigned int CR;
	volatile unsigned int PLLCFGR;
	volatile unsigned int CFGR;
	volatile unsigned int CIR;
	volatile unsigned int AHB1RSTR;
	volatile unsigned int AHB2RSTR;
	volatile unsigned int AHB3RSTR;
	volatile unsigned int reserved1;
	volatile unsigned int APB1RSTR;
	volatile unsigned int APB2RSTR;
	volatile unsigned int reserved2;
	volatile unsigned int reserved3;
	volatile unsigned int AHB1ENR;
	volatile unsigned int AHB2ENR;
	volatile unsigned int AHB3ENR;
	volatile unsigned int reserved4;
	volatile unsigned int APB1ENR;
	volatile unsigned int APB2ENR;
	volatile unsigned int reserved5;
	volatile unsigned int reserved6;
	volatile unsigned int AHB1LPENR;
	volatile unsigned int AHB2LPENR;
	volatile unsigned int AHB3LPENR;
	volatile unsigned int reserved7;
	volatile unsigned int APB1LPENR;
	volatile unsigned int APB2LPENR;
	volatile unsigned int reserved8;
	volatile unsigned int reserved9;
	volatile unsigned int BDCR;
	volatile unsigned int CSR;
	volatile unsigned int reserved10;
	volatile unsigned int reserved11;
	volatile unsigned int SSCGR;
	volatile unsigned int PLLI2SCFGR;
	volatile unsigned int PLLSAICFGR;
	volatile unsigned int DCKCFGR;
} _RCC;

typedef struct _SRAMSection
{
	volatile unsigned int BCR;
	volatile unsigned int BTR;
} _SRAMSection;

typedef struct _SRAM
{
	_SRAMSection bank[4];
} _SRAM;

typedef struct exti
{
	volatile unsigned int IMR;
	volatile unsigned int EMR;
	volatile unsigned int RTSR;
	volatile unsigned int FTSR;
	volatile unsigned int SWIER;
	volatile unsigned int PR;
} exti;

///////////////////////////////////////////////////////////////////////////////
// Definitions
///////////////////////////////////////////////////////////////////////////////
#define RCC ((_RCC*) 0x40023800)
#define FLASH ((_FLASH*) 0x40023C00)
#define FSMC ((_SRAM*) 0xA0000000)
#define EXTI ((exti*) 0x40013C00)
#define SYSCFG ((syscfg*) 0x40013800)
