/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef CAN_REG_TMS570_H
#define CAN_REG_TMS570_H

///////////////////////////////////////////////////////////////////////////////
// Registers
///////////////////////////////////////////////////////////////////////////////
typedef struct _CAN
{
	volatile unsigned int CTL;
	volatile unsigned int ES;
	volatile unsigned int ERRC;
	volatile unsigned int BTR;
	volatile unsigned int INT;
	volatile unsigned int TEST;
	volatile unsigned int r1;
	volatile unsigned int PERR;
	volatile unsigned int r2[24];
	volatile unsigned int ABOTR;
	volatile unsigned int TXRQX;
	volatile unsigned int TXRQ12;
	volatile unsigned int TXRQ34;
	volatile unsigned int TXRQ56;
	volatile unsigned int TXRQ78;
	volatile unsigned int NWDATX;
	volatile unsigned int NWDAT12;
	volatile unsigned int NWDAT34;
	volatile unsigned int NWDAT56;
	volatile unsigned int NWDAT78;
	volatile unsigned int INTPNDX;
	volatile unsigned int INTPND12;
	volatile unsigned int INTPND34;
	volatile unsigned int INTPND56;
	volatile unsigned int INTPND78;
	volatile unsigned int MSGVALX;
	volatile unsigned int MSGVAL12;
	volatile unsigned int MSGVAL34;
	volatile unsigned int MSGVAL56;
	volatile unsigned int MSGVAL78;
	volatile unsigned int r3;
	volatile unsigned int INTMUX12;
	volatile unsigned int INTMUX34;
	volatile unsigned int INTMUX56;
	volatile unsigned int INTMUX78;
	volatile unsigned int r4[6];

	volatile unsigned char IF1r;		// These regs expect 8-bit writes
	volatile unsigned char IF1CMD;
	volatile unsigned char IF1STAT;
	volatile unsigned char IF1NO;

	volatile unsigned int IF1MSK;
	volatile unsigned int IF1ARB;
	volatile unsigned int IF1MCTL;
	volatile unsigned int IF1DATA;
	volatile unsigned int IF1DATB;
	volatile unsigned int r5[2];

	volatile unsigned char IF2r;		// These regs expect 8-bit writes
	volatile unsigned char IF2CMD;
	volatile unsigned char IF2STAT;
	volatile unsigned char IF2NO;

	volatile unsigned int IF2MSK;
	volatile unsigned int IF2ARB;
	volatile unsigned int IF2MCTL;
	volatile unsigned int IF2DATA;
	volatile unsigned int IF2DATB;
	volatile unsigned int r6[2];
	volatile unsigned int IF3OBS;
	volatile unsigned int IF3MSK;
	volatile unsigned int IF3ARB;
	volatile unsigned int IF3MCTL;
	volatile unsigned int IF3DATA;
	volatile unsigned int IF3DATB;
	volatile unsigned int r7[2];
	volatile unsigned int IF3UPD12;
	volatile unsigned int IF3UPD34;
	volatile unsigned int IF3UPD56;
	volatile unsigned int IF3UPD78;
	volatile unsigned int r8[28];
	volatile unsigned int TIOC;
	volatile unsigned int RIOC;
}_CAN;

#define CAN1 ((_CAN*) 0xFFF7DC00)
#define CAN2 ((_CAN*) 0xFFF7DE00)
#define CAN3 ((_CAN*) 0xFFF7E000)

#endif
