/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef DMA_REG_TMS570_H
#define DMA_REG_TMS570_H

///////////////////////////////////////////////////////////////////////////////
// Registers
///////////////////////////////////////////////////////////////////////////////
typedef struct _DMA
{
	volatile unsigned int GCTRL;
	volatile unsigned int PEND;
	volatile unsigned int r1;
	volatile unsigned int DMASTAT;
	volatile unsigned int r2;
	volatile unsigned int HWCHENAS;
	volatile unsigned int r3;
	volatile unsigned int HWCHENAR;
	volatile unsigned int r4;
	volatile unsigned int SWCHENAS;
	volatile unsigned int r5;
	volatile unsigned int SWCHENAR;
	volatile unsigned int r6;
	volatile unsigned int CHPRIOS;
	volatile unsigned int r8;
	volatile unsigned int CHPRIOR;
	volatile unsigned int r9;
	volatile unsigned int GCHIENAS;
	volatile unsigned int r10;
	volatile unsigned int GCHIENAR;
	volatile unsigned int r11;
	volatile unsigned int DREQASI[4];
	volatile unsigned int r12[12];
	volatile unsigned int PAR[2];
	volatile unsigned int r13[6];
	volatile unsigned int FTCMAP;
	volatile unsigned int r14;
	volatile unsigned int LFSMAP;
	volatile unsigned int r15;
	volatile unsigned int HBCMAP;
	volatile unsigned int r16;
	volatile unsigned int BTCMAP;
	volatile unsigned int r17[4];
	volatile unsigned int FTCINTENAS;
	volatile unsigned int r18;
	volatile unsigned int FTCINTENAR;
	volatile unsigned int r19;
	volatile unsigned int LFSINTENAS;
	volatile unsigned int r20;
	volatile unsigned int LFSINTENAR;
	volatile unsigned int r21;
	volatile unsigned int HBCINTENAS;
	volatile unsigned int r22;
	volatile unsigned int HBCINTENAR;
	volatile unsigned int BTCINTENAS;
	volatile unsigned int r23;
	volatile unsigned int BTCINTENAR;
	volatile unsigned int r24;
	volatile unsigned int GINTFLAG;
	volatile unsigned int r25;
	volatile unsigned int FTCFLAG;
	volatile unsigned int r26;
	volatile unsigned int LFSFLAG;
	volatile unsigned int r27;
	volatile unsigned int HBCFLAG;
	volatile unsigned int r28;
	volatile unsigned int BTCFLAG;
	volatile unsigned int r29;
	volatile unsigned int BERFLAG;
	volatile unsigned int r30;
	volatile unsigned int FTCAOFFSET;
	volatile unsigned int LFSAOFFSET;
	volatile unsigned int HBCAOFFSET;
	volatile unsigned int BTCAOFFSET;
	volatile unsigned int r31;
	volatile unsigned int FTCBOFFSET;
	volatile unsigned int LFSBOFFSET;
	volatile unsigned int HBCBOFFSET;
	volatile unsigned int BTCBOFFSET;
	volatile unsigned int r32[2];
	volatile unsigned int PTCRL;
	volatile unsigned int RTCTRL;
	volatile unsigned int DCTRL;
	volatile unsigned int WPR;
	volatile unsigned int WMR;
	volatile unsigned int r33[3];
	volatile unsigned int PBACSADDR;
	volatile unsigned int PBACDADDR;
	volatile unsigned int PBACTC;
	volatile unsigned int r34;
	volatile unsigned int DMAPCR;
	volatile unsigned int DMAPAR;
	volatile unsigned int DMAMPCTRL;
	volatile unsigned int DMAMPST;
	volatile unsigned int DMAMPR0S;
	volatile unsigned int DMAMPR0E;
	volatile unsigned int DMAMPR1S;
	volatile unsigned int DMAMPR1E;
	volatile unsigned int DMAMPR2S;
	volatile unsigned int DMAMPR2E;
	volatile unsigned int DMAMPR3S;
	volatile unsigned int DMAMPR3E;
} _DMA;

typedef struct _DMAPCP
{
	volatile unsigned int ISADDR;
	volatile unsigned int IDADDR;
	volatile unsigned int ITCOUNT;
	volatile unsigned int r1;
	volatile unsigned int CHCTRL;
	volatile unsigned int EIOFF;
	volatile unsigned int FIOFF;
	volatile unsigned int r2;
}_DMAPCP;

typedef struct _DMAWCP
{
	volatile unsigned int CSADDR;
	volatile unsigned int CDADDR;
	volatile unsigned int CTCOUNT;
	volatile unsigned int r1;
}_DMAWCP;

typedef struct _DMACH
{
	_DMAPCP PCP[32];
	volatile unsigned int r1[256];
	_DMAWCP WCP[32];
}_DMACH;

#define DMA ((_DMA*) 0xFFFFF000)
#define DMACH ((_DMACH*) 0xFFF80000)

#endif
