/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef EPWM_REG_TMS570_H
#define EPWM_REG_TMS570_H

///////////////////////////////////////////////////////////////////////////////
// Registers
///////////////////////////////////////////////////////////////////////////////
typedef struct _EPWM
{
	volatile unsigned short TBSTS;		// Offset 00h
	volatile unsigned short TBCTL;
	volatile unsigned short TBPHS;
	volatile unsigned short r0;
	volatile unsigned short TBPRD;
	volatile unsigned short TBCTR;
	volatile unsigned short CMPCTL;
	volatile unsigned short r1;
	volatile unsigned short CMPA;		// Offset 10h
	volatile unsigned short r2;
	volatile unsigned short AQCTLA;
	volatile unsigned short CMPB;
	volatile unsigned short AQSFRC;
	volatile unsigned short AQCTLB;
	volatile unsigned short DBCTL;
	volatile unsigned short AQCSFRC;
	volatile unsigned short DBFED;		// Offset 20h
	volatile unsigned short DBFRED;
	volatile unsigned short TZDCSEL;
	volatile unsigned short TZSEL;
	volatile unsigned short TZINT;
	volatile unsigned short TZEINT;
	volatile unsigned short TZCTL;
	volatile unsigned short TZCLR;
	volatile unsigned short TZFLG;
	volatile unsigned short ETSEL;		// Offset 30h
	volatile unsigned short TZFRC;
	volatile unsigned short ETFLG;
	volatile unsigned short ETPS;
	volatile unsigned short ETFRC;
	volatile unsigned short ETCLR;
	volatile unsigned short r3;
	volatile unsigned short PCCTL;
	volatile unsigned int r4[8];		// Offset 40h to 5Fh
	volatile unsigned short DCACTL;		// Offset 60h
	volatile unsigned short DCTRIPSEL;
	volatile unsigned short DCFCTL;
	volatile unsigned short DCBCTL;
	volatile unsigned short DCFOFFSET;
	volatile unsigned short DCCAPCTL;
	volatile unsigned short DCFWINDOW;
	volatile unsigned short DCFOFFSETCNT;
	volatile unsigned short DCCAP;		// Offset 70h
	volatile unsigned short DCFWINDOWCNT;
}_EPWM;

#define EPWM1 ((_EPWM*) 0xFCF78C00)
#define EPWM2 ((_EPWM*) 0xFCF78D00)
#define EPWM3 ((_EPWM*) 0xFCF78E00)
#define EPWM4 ((_EPWM*) 0xFCF78F00)
#define EPWM5 ((_EPWM*) 0xFCF79000)
#define EPWM6 ((_EPWM*) 0xFCF79100)
#define EPWM7 ((_EPWM*) 0xFCF79200)

#endif
