/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef GIO_REG_TMS570_H
#define GIO_REG_TMS570_H

///////////////////////////////////////////////////////////////////////////////
// Registers
///////////////////////////////////////////////////////////////////////////////
typedef struct _GIOAB
{
	volatile unsigned int DIR;
	volatile unsigned int DIN;
	volatile unsigned int DOUT;
	volatile unsigned int DSET;
	volatile unsigned int DCLR;
	volatile unsigned int PDR;
	volatile unsigned int PULDIS;
	volatile unsigned int PSL;
}_GIOAB;

typedef struct _GIO
{
	volatile unsigned int GCR0;
	volatile unsigned int r1;

	volatile unsigned int INTDET;
	volatile unsigned int POL;
	volatile unsigned int ENASET;
	volatile unsigned int ENACLR;
	volatile unsigned int LVLSET;
	volatile unsigned int LVLCLR;
	volatile unsigned int FLG;

	volatile unsigned int OFF1;
	volatile unsigned int OFF2;
	volatile unsigned int EMU1;
	volatile unsigned int EMU2;

	_GIOAB a;
	_GIOAB b;
}_GIO;

#define GIO ((_GIO*) 0xFFF7BC00)

#endif
