/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef I2C_REG_TMS570_H
#define I2C_REG_TMS570_H

///////////////////////////////////////////////////////////////////////////////
// Registers
///////////////////////////////////////////////////////////////////////////////
typedef struct _I2C
{
	volatile unsigned int OAR;
	volatile unsigned int IMR;
	volatile unsigned int STR;
	volatile unsigned int CKL;
	volatile unsigned int CKH;
	volatile unsigned int CNT;
	volatile unsigned int DRR;
	volatile unsigned int SAR;
	volatile unsigned int DXR;
	volatile unsigned int MDR;
	volatile unsigned int IVR;
	volatile unsigned int EMDR;
	volatile unsigned int PSC;
	volatile unsigned int PID1;
	volatile unsigned int PID2;
	volatile unsigned int DMACR;
	volatile unsigned int r1[2];
	volatile unsigned int PFNC;
	volatile unsigned int PDIR;
	volatile unsigned int DIN;
	volatile unsigned int DOUT;
	volatile unsigned int DSET;
	volatile unsigned int DCLR;
	volatile unsigned int PDR;
	volatile unsigned int PDIS;
	volatile unsigned int PSEL;
	volatile unsigned int SRS;
}_I2C;

#define I2C1 ((_I2C*) 0xFFF7D400)

#endif
