/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef SPI_REG_TMS570_H
#define SPI_REG_TMS570_H

///////////////////////////////////////////////////////////////////////////////
// Registers
///////////////////////////////////////////////////////////////////////////////
typedef struct _SPI
{
	volatile unsigned int SPIGCR0;
	volatile unsigned int SPIGCR1;
	volatile unsigned int SPIINT0;
	volatile unsigned int SPILVL;
	volatile unsigned int SPIFLG;
	volatile unsigned int SPIPC0;
	volatile unsigned int SPIPC1;
	volatile unsigned int SPIPC2;
	volatile unsigned int SPIPC3;
	volatile unsigned int SPIPC4;
	volatile unsigned int SPIPC5;
	volatile unsigned int SPIPC6;
	volatile unsigned int SPIPC7;
	volatile unsigned int SPIPC8;
	volatile unsigned int SPIDAT0;
	volatile unsigned int SPIDAT1;
	volatile unsigned int SPIBUF;
	volatile unsigned int SPIEMU;
	volatile unsigned int SPIDELAY;
	volatile unsigned int SPIDEF;
	volatile unsigned int SPIFMT[4];
	volatile unsigned int INTVECT0;
	volatile unsigned int INTVECT1;
	volatile unsigned int SPIPC9;
	volatile unsigned int SPIPMCTRL;
	volatile unsigned int MIBSPIE;
	volatile unsigned int TGITENST;
	volatile unsigned int TGITENCR;
	volatile unsigned int TGITLVST;
	volatile unsigned int TGITLVCR;
	volatile unsigned int TGINTFLG;
	volatile unsigned int r1[2];
	volatile unsigned int TICKCNT;
	volatile unsigned int LTGPEND;
	volatile unsigned int TGxCTRL[16];
	volatile unsigned int DMAxCTRL[8];
	volatile unsigned int ICOUNT[8];
	volatile unsigned int DMACNTLEN;
	volatile unsigned int r2;
	volatile unsigned int UERRCTRL;
	volatile unsigned int UERRSTAT;
	volatile unsigned int UERRADDR1;
	volatile unsigned int UERRADDR0;
	volatile unsigned int RXOVRN_BUF_ADDR;
	volatile unsigned int IOLPBKTSTCR;
	volatile unsigned int EXTENDED_PRESCALE1;
	volatile unsigned int EXTENDED_PRESCALE2;
}_SPI;

#define SPI1 ((_SPI*) 0xFFF7F400)
#define SPI2 ((_SPI*) 0xFFF7F600)
#define SPI3 ((_SPI*) 0xFFF7F800)
#define SPI4 ((_SPI*) 0xFFF7FA00)
#define SPI5 ((_SPI*) 0xFFF7FC00)

#endif
