/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef SCI_REG_TMS570_H
#define SCI_REG_TMS570_H

///////////////////////////////////////////////////////////////////////////////
// Registers
///////////////////////////////////////////////////////////////////////////////
typedef struct _SCI
{
	volatile unsigned int GCR0;
	volatile unsigned int GCR1;
	volatile unsigned int r1;
	volatile unsigned int SETINT;
	volatile unsigned int CLEARINT;
	volatile unsigned int SETINTLVL;
	volatile unsigned int CLEARINTLVL;
	volatile unsigned int FLR;
	volatile unsigned int INTVECT0;
	volatile unsigned int INTVECT1;
	volatile unsigned int FORMAT;
	volatile unsigned int BRS;
	volatile unsigned int ED;
	volatile unsigned int RD;
	volatile unsigned int TD;
	volatile unsigned int PIO0;
	volatile unsigned int PIO1;
	volatile unsigned int PIO2;
	volatile unsigned int PIO3;
	volatile unsigned int PIO4;
	volatile unsigned int PIO5;
	volatile unsigned int PIO6;
	volatile unsigned int PIO7;
	volatile unsigned int PIO8;
	volatile unsigned int r2[12];
	volatile unsigned int IODFTCTRL;
}_SCI;

#define SCI1 ((_SCI*) 0xFFF7E500)
#define SCI2 ((_SCI*) 0xFFF7E400)

#endif
