/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef CAN_H
#define CAN_H

///////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////
#include "arch/tms570ls1224/can.h"
#include "sched/threadcontrol.h"

///////////////////////////////////////////////////////////////////////////////
// Definitions
///////////////////////////////////////////////////////////////////////////////

// Extended format (29-bit id) flag
#define CAN_EFF_FLAG 0x80000000
#define CAN_EFF_MASK (~CAN_EFF_FLAG)

///////////////////////////////////////////////////////////////////////////////
// Structures
///////////////////////////////////////////////////////////////////////////////
struct can_frame
{
	unsigned int can_id;
	unsigned char can_dlc;
	char padding1;
	char padding2;
	char padding3;
	unsigned char data[8];
};

///////////////////////////////////////////////////////////////////////////////
// Structures
///////////////////////////////////////////////////////////////////////////////
struct can
{
	// Instance handle to the registers
	_CAN *instance;

	// The index number of this instance
	unsigned int num;

	// Used to send a signal
	struct ThreadControl *trc;

	// Current receive index in the FIFO
	int rxindex;
};

#endif
