/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef FBCON_H
#define FBCON_H

///////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////
#include "timer/timer.h"
#include "../config/live/drivers/fbcon.h"

///////////////////////////////////////////////////////////////////////////////
// Structures
///////////////////////////////////////////////////////////////////////////////
typedef struct FBConData
{
	// Size in pixels, gotten from the lcd driver
	short width;
	short height;

	// Size in characters
	short width_chars;
	short height_chars;
	short charwidth;
	short charheight;

	// Current position in pixels
	short posx;
	short posy;

	// Foreground and background color
	unsigned short fcolor;
	unsigned short bcolor;

	// Cursor data
#if FBCON_OPTION_CURSOR
	TimerHandle cursortimer;
	char *data;
	char cursormarked;
#endif

	// Escape sequence processing
	short inescape;
	char colarg[8];

	// Print if tty is not in direct mode
	char donotprint;
} FBConData;

#endif
