/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef IR_H
#define IR_H

///////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////
#include "arch/stm32f407/timer.h"

///////////////////////////////////////////////////////////////////////////////
// Structures
///////////////////////////////////////////////////////////////////////////////
typedef struct ir
{
	// Instance
	timer_regs *instance;

	// State
	unsigned int oldtim;
	unsigned int keystate;
	unsigned int key;
	unsigned int state;

	// Timer input data
	unsigned char values[75];

	// Foreground tty group
	int ir_group;

	// Output queue
	char queue_keys[16];
	short queue_rdpos;
	short queue_wrpos;
	short repetition;
	char rep_char;

	// Caps lock state
	char capslock;
} ir;

///////////////////////////////////////////////////////////////////////////////
// Externs
///////////////////////////////////////////////////////////////////////////////
extern const unsigned char key2ascii[128];
extern const unsigned char key2asciishifted[128];
extern const unsigned char key2asciialtgr[128];

#endif
