/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef STRING_H
#define STRING_H

///////////////////////////////////////////////////////////////////////////////
// Functions
///////////////////////////////////////////////////////////////////////////////
void StrCpy (char *dst, const char *src);
void StrCat (char *dst, const char *src);
void MemSet (void *dst, int val, unsigned int nbytes);
void MemCpy (void *dst, void *src, unsigned int nbytes);
int MemCmp (const void *dst, const void *src, unsigned int nbytes);
int StrCmp (const char *a, const char *b);
int StrLen (const char *s);
void Reverse (char *s);
char *strtok (char *in, char *match);
int atoi (char *in);

#endif
