/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef DATAFRAME_H
#define DATAFRAME_H

///////////////////////////////////////////////////////////////////////////////
// Definitions
///////////////////////////////////////////////////////////////////////////////

// Protocol
#define LAYER2_BROADCAST 0xF0F0
#define PACKETSEPARATOR 255
#define DATAFRAME_HEADSIZE 6
#define DATAFRAME_SIZE 7

///////////////////////////////////////////////////////////////////////////////
// Protocol structures
///////////////////////////////////////////////////////////////////////////////
typedef struct DataFrame
{
	// Header
	unsigned short destination;
	unsigned short source;
	unsigned char protocol;
	unsigned char checksum;

	// Payload segment
	unsigned char payload[250];

	// Extra data, not sent on the wire
	unsigned char size;
	struct Layer2 *originatinginterface;

	// Pointer for making lists of data frames
	struct DataFrame *next;
}DataFrame;

#endif
