/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

//
// Created by erlendjs on 14/04/16.
//

#ifndef NETWORK_LAYER2_FRAMEPOOL_H
#define NETWORK_LAYER2_FRAMEPOOL_H

///////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////
#include "net/enet/layer2/dataframe.h"

///////////////////////////////////////////////////////////////////////////////
// Functions
///////////////////////////////////////////////////////////////////////////////

// Clears the in-use flag in the statically allocated frame pool
void FramepoolInit (void);

// Allocate space for a new frame. Note: Not thread safe!
DataFrame *FramepoolNew (void);

// Free the memory of a frame
void FramepoolDelete (DataFrame *frame);

#endif
