/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef LAYER2_MANAGER_H
#define LAYER2_MANAGER_H

///////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////
#include "net/enet/layer2/interface.h"

///////////////////////////////////////////////////////////////////////////////
// Functions
///////////////////////////////////////////////////////////////////////////////

// Global init function
void Layer2GlobalInit (void);

// Get next frame
// WARNING: Ownership transfer!
DataFrame *Layer2GlobalPull (void);

// Check for data
DataFrame *Layer2CheckPos (Layer2 *l);

/*
 * Send a data frame. If successful, it takes ownership of the
 * frame object and deletes it when transfer is complete. If the
 * function fails, it is up to the caller to decide what to do with
 * the object, it is not deleted by SendFrame.
 */
int Layer2SendFrame (Layer2 *l, DataFrame *frame);

// Always takes ownership
void Layer2StoreFifo (Layer2 *l, DataFrame *frame);

#endif
