/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

//
// Created by erlendjs on 10/05/16.
//

#ifndef NETWORK_NETWORK_H
#define NETWORK_NETWORK_H

///////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////
#ifndef NOTKERNEL
#include "../config/live/network-config.h"
#include "net/enet/layer4/udp.h"
#endif

#include "net/enet/layer2/linkspeed.h"

///////////////////////////////////////////////////////////////////////////////
// Structures
///////////////////////////////////////////////////////////////////////////////
struct ENetGlobals
{
	Layer2 *iflist;
	unsigned short myip;
	unsigned short defaultgateway;
};

///////////////////////////////////////////////////////////////////////////////
// Externs
///////////////////////////////////////////////////////////////////////////////
extern struct ENetGlobals eglobals;

///////////////////////////////////////////////////////////////////////////////
// Functions
///////////////////////////////////////////////////////////////////////////////
/*
 * Initialize the network stack. Arguments:
 *   The IP address to use
 */
void NetInit (unsigned short myipaddress);

/*
 * Process network
 */
void NetPump (void);

/*
 * Is the network up?
 */
int NetLinkUp (void);

#endif
