/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef INET_H
#define INET_H

///////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////
#include "posix/netinet/in.h"

///////////////////////////////////////////////////////////////////////////////
// Functions
///////////////////////////////////////////////////////////////////////////////
unsigned int htonl (unsigned int);
unsigned short htons (unsigned short);
unsigned int ntohl (unsigned int);
unsigned short ntohs (unsigned short);

in_addr_t inet_addr (const char *);
char *inet_ntoa (struct in_addr);
const char *inet_ntop (int, const void *restrict, char *restrict, socklen_t);
int inet_pton (int, const char *restrict, void *restirct);

#endif
