/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef STATVFS_H
#define STATVFS_H

///////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////
#include "posix/sys/types.h"

///////////////////////////////////////////////////////////////////////////////
// Constants
///////////////////////////////////////////////////////////////////////////////
#define ST_RDONLY 0
#define ST_NOSUID 1

///////////////////////////////////////////////////////////////////////////////
// Structures
///////////////////////////////////////////////////////////////////////////////
struct statvfs
{
	unsigned long f_bsize;		// File system block size
	unsigned long f_frsize;		// Fragment size

	fsblkcnt_t f_blocks;		// Size of fs in f_frsize units
	fsblkcnt_t f_bfree;			// Number of free blocks
	fsblkcnt_t f_bavail;		// Number of free blocks for unprivileged users

	fsfilcnt_t f_files;			// Number of nodes
	fsfilcnt_t f_ffree;			// Number of free nodes
	fsfilcnt_t f_favail;		// Number of free nodes for unprivileged users

	unsigned long f_fsid;		// Filesystem ID
	unsigned long f_flag;		// Mount flags
	unsigned long f_namemax;	// Maximum filename length
};

#endif
