/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef TYPES_H
#define TYPES_H

///////////////////////////////////////////////////////////////////////////////
// Definitions
///////////////////////////////////////////////////////////////////////////////

// For system times in clock ticks
typedef unsigned long clock_t;

// For device IDs
typedef unsigned long dev_t;

// For statvfs
typedef unsigned long fsblkcnt_t;
typedef unsigned long fsfilcnt_t;

// For group IDs
typedef unsigned long gid_t;

// For file serial numbers
typedef unsigned long ino_t;

// Used for file attributes
typedef unsigned long mode_t;

// Used for link counts
typedef unsigned long nlink_t;

// For file sizes
typedef unsigned long off_t;

// Used for process IDS and process group IDs
typedef long pid_t;

// Used for sizes of objects
typedef unsigned long size_t;

// Used for a count of bytes or an error indication
typedef unsigned long ssize_t;

// Used for time in seconds
typedef long time_t;

// Used for time in microseconds
typedef unsigned long useconds_t;
typedef long suseconds_t;

// Used for user IDs
typedef unsigned long uid_t;

// Block size
typedef unsigned long blksize_t;
typedef unsigned long blkcnt_t;

#endif
