/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef PROCESSCONTROL_H
#define PROCESSCONTROL_H

///////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////
#include "sched/threadcontrol.h"
#include "../config/live/kernelconfig.h"

///////////////////////////////////////////////////////////////////////////////
// Structures
///////////////////////////////////////////////////////////////////////////////
struct ProcessControl
{
	struct ThreadControl trc;			// Process control data for scheduler
	unsigned int alloc[4];				// Pointers to allocation blocks
	unsigned int *stack;				// 2KiB default stack?
	unsigned int text;					// Copy of pointer to text section
	short inuse;						// Is this struct instance in use or not
	short ownerpid;						// Process id of the parent process
	short pid;							// Process id
	short gid;							// Group id
	int returncode;						// Return code provided by exit
	char **argv;						// Argument list
	char **environ;						// Environment
	char cwd[64];						// Current working directory
	unsigned char fnodes[MAX_NODES];	// Table mapping user fd numbers to kernel
};

#endif
