/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef LIST_H
#define LIST_H

///////////////////////////////////////////////////////////////////////////////
// Structures
///////////////////////////////////////////////////////////////////////////////
typedef struct ListItem
{
	struct ListItem *next;
	struct ListItem *previous;
	struct ThreadControl *parent;
	struct List *container;
	unsigned int sortvalue;
} ListItem;

typedef struct List
{
	unsigned int nitems;
	struct ListItem *current;
	struct ListItem *last;
	unsigned int stepback;
} List;

///////////////////////////////////////////////////////////////////////////////
// Functions
///////////////////////////////////////////////////////////////////////////////

// list.c
void ListInit (List *l);
void ListAdd (List *l, ListItem *it);
void ListAddSorted (List *l, ListItem *it, unsigned int sortvalue);
void ListRemove (ListItem *it);

// listverify.c
void ListVerify (List *l);

#endif
