/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

///////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////
#include "sched/scheduler.h"

///////////////////////////////////////////////////////////////////////////////
// Functions
///////////////////////////////////////////////////////////////////////////////

/*
 * Post signal sig to thread thc. Returns zero on success, 1 otherwise.
 * The thread will only handle the signal immediately if it is not the current
 * thread and it is not already handling a signal. Othewise, the handler will
 * either happen when the current signal is processed or, if current, a
 * reschedule is issed and the signal handler is set up by the scheduler
 * instead.
 */
int SchedPostSignal (struct ThreadControl *thc, int sig);

/*
 * Stack setup, not to be called directly.
 */
void SchedSignalStackSetup (struct ThreadControl *thc);
