/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

SECTIONS
{
	.vectortable :
	{
		. = ALIGN(4);
		KEEP(*(.vectortable))
		KEEP(*(.vectortable*))
		. = ALIGN(4);
	} > FLASH

	.text :
	{
		. = ALIGN(4);
		*(.text)
		*(.text*)
		. = ALIGN(4);
	} > FLASH

	.rodata :
	{
		. = ALIGN(4);
		*(.rodata)
		*(.rodata*)
		. = ALIGN(4);
	} > FLASH

	.dev_list :
	{
		PROVIDE (__dev_list_start = .);
		KEEP (*(.dev_list))
		PROVIDE (__dev_list_end = .);
	} >FLASH

	.kmod_list :
	{
		PROVIDE (__kmod_list_start = .);
		KEEP (*(.kmod_list))
		PROVIDE (__kmod_list_end = .);
	} >FLASH

	.net_list :
	{
		PROVIDE (__net_list_start = .);
		KEEP (*(.net_list))
		PROVIDE (__net_list_end = .);
	} >FLASH

	/* Provide symbols for zeroing the RAM */
	_ramstart = ORIGIN(RAM);
	_ramend = ORIGIN(RAM) + LENGTH(RAM);

	/* Supply the stack at the beginning of RAM.
	 * This way we will get a fault if it overflows!
	 * Also supply symbols for initializing it, making it
	 * easy to see how much stack we used.
	 */
	.stack :
	{
		. = ALIGN(4);
		kernelstackstart = .;
		. = . + 4K;
		kernelstack = .;
	} > RAM

	.bss :
	{
		. = ALIGN(4);
		*(.bss)
		*(.bss*)
		. = ALIGN(4);
	} > RAM

	_dataloadfrom = LOADADDR(.data);

	.data :
	{
		. = ALIGN(4);
		_datastart = .;
		*(.data)
		*(.data*)
		. = ALIGN(4);
		_dataend = .;
	} > RAM AT > FLASH
}
