/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

.syntax unified
.cpu cortex-m4
.fpu softvfp
.thumb

.section .text.SchedStartAsm
.global SchedStartAsm
.type SchedStartAsm, %function
SchedStartAsm:
	cpsie i
	cpsie f
	svc 63
	nop
.size SchedStartAsm, .-SchedStartAsm

.section .text.SchedStartSvc
.global SchedStartSvc
.type SchedStartSvc, %function
SchedStartSvc:
								@ TODO: Start systick irq here
	ldr r0, =kernelstack		@ Reset kernel stack
	msr msp, r0
	ldr	r3, =currentthc			@ Get current thread
	ldr r1, [r3]
	ldr r0, [r1]				@ Get stacktop and unstack regs
	ldmia r0!, {r4-r11, r14}
	msr psp, r0					@ Set thread stack.
	mov r0, #0					@ Use privileged mode for the first process started.
	msr	basepri, r0				@ It will always be a kernel thead so no need to bother
	msr control, r0				@ with the MPU yet.
	bx r14						@ The CPU unstacks the rest of the regs here.
.size SchedStartSvc, .-SchedStartSvc

.section .text.SchedEnterCritical
.global SchedEnterCritical
.type SchedEnterCritical, %function
SchedEnterCritical:
	cpsid i
	bx lr
.size SchedEnterCritical, .-SchedEnterCritical

.section .text.SchedExitCritical
.global SchedExitCritical
.type SchedExitCritical, %function
SchedExitCritical:
	cpsie i
	bx lr
.size SchedExitCritical, .-SchedExitCritical
