/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

.syntax unified
.cpu cortex-r4
.thumb

///////////////////////////////////////////////////////////////////////////////
// External functions
///////////////////////////////////////////////////////////////////////////////

// ticore.s
.extern CoreInitRegisters
.extern _errata_CORTEXR4_57_
.extern _errata_CORTEXR4_66_

// resethandler.s
.extern KernelStackInit

// kernelinit.c
.extern KernelInit

///////////////////////////////////////////////////////////////////////////////
// Functions
///////////////////////////////////////////////////////////////////////////////
.section .text.StartupFunction
.global StartupFunction
.type StartupFunction, %function
StartupFunction:
	// This is the startup code needed for the processor, and some errata.
	// Could not find a proper datasheet for this for reimplementing it,
	// so getting the code from ti (ticore.s)
	blx CoreInitRegisters
	ldr r0, =kernelstack
	mov sp, r0
	blx _errata_CORTEXR4_57_
	blx _errata_CORTEXR4_66_

	// Stack setup, branches to kernel init
	b KernelStackInit
.size StartupFunction, .-StartupFunction
