/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

.syntax unified
.cpu cortex-r4
.arm

.section .text.TickIrq
.global TickIrq
.type TickIrq, %function
TickIrq:
	stmfd sp!, {r0-r3,lr}		@ Stack regs that will be overwritten
	blx PlatformIncrementTick	@ Branch to platform code
	ldmfd sp!, {r0-r3,lr}		@ Unstack
	subs pc, lr, #4				@ Return correctly
.size TickIrq, .-TickIrq
