/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

///////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////
#include "drivers/gpio/gpio-stm32f103.h"

///////////////////////////////////////////////////////////////////////////////
// Functions
///////////////////////////////////////////////////////////////////////////////
void GPIOInit (GPIO *gpio, int pins, int mode)
{
	for (int pin = 1, pinnum = 0; pinnum < 16; pin = pin << 1, pinnum++)
	{
		// Skip unspecified pin
		if (!(pins & pin))
			continue;

		if (pinnum >= 8)
		{
			unsigned int shifter = ((pinnum - 8) << 2);
			gpio->CRH &= ~(0x0F << shifter);
			gpio->CRH |= mode << shifter;
		}
		else
		{
			unsigned int shifter = pinnum << 2;
			gpio->CRL &= ~(0x0F << shifter);
			gpio->CRL |= mode << shifter;
		}
	}
}
