/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

/*
 * Crappy devnode for blinking some leds
 */

///////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////
#include "fs/vfs.h"
#include "fs/dev/dev.h"
#include "posix/errno.h"
#include "ioctl/ioctl.h"
#include "drivers/gpio/gpio-stm32f407.h"

///////////////////////////////////////////////////////////////////////////////
// Driver functions
///////////////////////////////////////////////////////////////////////////////
int dev_led_open (struct FileNode *node, const char *filename)
{
	GPIOInit (GPIOD, PIN(10) | PIN(11) |
		PIN(12) | PIN(13) | PIN(14) | PIN(15),
		GPIO_OUTPUT | GPIO_OPENDRAIN);

	GPIOInit (GPIOD, PIN(8) | PIN(9), GPIO_OUTPUT);

	return 0;
}

int dev_led_close (struct FileNode *node)
{
	return 0;
}

int dev_led_read (struct FileNode *node, void *data, unsigned int nbytes)
{
	return 0;
}

int dev_led_write (struct FileNode *node, void *data, unsigned int nbytes)
{
	unsigned int reg = GPIOD->ODR;
	reg &= 0x00FF;
	reg |= (unsigned int) ((unsigned char*)data)[0] << 8;
	GPIOD->ODR = reg;
	return nbytes;
}

int dev_led_ioctl (struct FileNode *node, unsigned int code, void *data)
{
	switch (code)
	{
	default:
		// Unknown ioctl: Return "Inappropriate ioctl for device"
		return -ENOTTY;
	}

	// Default return value
	return 0;
}

///////////////////////////////////////////////////////////////////////////////
// Driver declarations
///////////////////////////////////////////////////////////////////////////////
MODULE_DESCRIPTOR (led,
	dev_led_open,
	dev_led_close,
	dev_led_read,
	dev_led_write,
	dev_led_ioctl,
	"led");
