/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

///////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////
#include "drivers/tty/tty-stm32.h"

///////////////////////////////////////////////////////////////////////////////
// Variables
///////////////////////////////////////////////////////////////////////////////
extern tty *irq_instances[TTY_N_MODULES];

///////////////////////////////////////////////////////////////////////////////
// IRQ functions
///////////////////////////////////////////////////////////////////////////////
#if TTY_ENABLE_AVAIL_0
void DMA1CH5_IrqHandler (void)
{
	DMAIRQHandler (&irq_instances[0]->dmarx);
}

void DMA1CH4_IrqHandler (void)
{
	DMAIRQHandler (&irq_instances[0]->dmatx);
}

void UART1_IrqHandler (void)
{
	irq_instances[0]->irq (irq_instances[0]);
}
#endif

#if TTY_ENABLE_AVAIL_1
void DMA1CH6_IrqHandler (void)
{
	DMAIRQHandler (&irq_instances[1]->dmarx);
}

void DMA1CH7_IrqHandler (void)
{
	DMAIRQHandler (&irq_instances[1]->dmatx);
}

void UART2_IrqHandler (void)
{
	irq_instances[1]->irq (irq_instances[1]);
}
#endif

#if TTY_ENABLE_AVAIL_2
void DMA1CH3_IrqHandler (void)
{
	DMAIRQHandler (&irq_instances[2]->dmarx);
}

void DMA1CH2_IrqHandler (void)
{
	DMAIRQHandler (&irq_instances[2]->dmatx);
}

void UART3_IrqHandler (void)
{
	irq_instances[2]->irq (irq_instances[2]);
}
#endif
