/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

/*
 * This is where the CPU starts executing when it encounters an SVC or SWI
 * instruction. It essentially just runs the correct function in the dispatch
 * table.
 */

.section .text
.syntax unified
.cpu cortex-r4
.arm

.weak tty_asm_jump
.type tty_asm_jump, %function
tty_asm_jump:
	stmfd sp!, {r0-r3,lr}		@ Stack regs that will be overwritten
	mov r0, #0
	blx dev_tty_irq				@ Branch to platform code
	ldmfd sp!, {r0-r3,lr}		@ Unstack
	subs pc, lr, #4				@ Return correctly
.size tty_asm_jump, .-tty_asm_jump
