/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

///////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////
#include "posix/arpa/inet.h"

///////////////////////////////////////////////////////////////////////////////
// Functions
///////////////////////////////////////////////////////////////////////////////
unsigned int htonl (unsigned int in)
{
	unsigned int ret = 0;
	ret |= (in & 0xFF000000) >> 24;
	ret |= (in & 0x00FF0000) >> 8;
	ret |= (in & 0x0000FF00) << 8;
	ret |= (in & 0x000000FF) << 24;
	return ret;
}

unsigned short htons (unsigned short in)
{
	unsigned short ret = 0;
	ret |= (in & 0xFF00) >> 8;
	ret |= (in & 0x00FF) << 8;
	return ret;
}

unsigned int ntohl (unsigned int in)
{
	unsigned int ret = 0;
	ret |= (in & 0xFF000000) >> 24;
	ret |= (in & 0x00FF0000) >> 8;
	ret |= (in & 0x0000FF00) << 8;
	ret |= (in & 0x000000FF) << 24;
	return ret;
}

unsigned short ntohs (unsigned short in)
{
	unsigned short ret = 0;
	ret |= (in & 0xFF00) >> 8;
	ret |= (in & 0x00FF) << 8;
	return ret;
}

in_addr_t inet_addr (const char *str)
{
	// TODO
	return 0;
}

char *inet_ntoa (struct in_addr in)
{
	// TODO
	return "0.0.0.0";
}

const char *inet_ntop (int, const void *restrict, char *restrict, socklen_t);
int inet_pton (int, const char *restrict, void *restirct);
