/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

///////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////
#include "process/process-allocate.h"
#include "mem/string.h"

///////////////////////////////////////////////////////////////////////////////
// Variables
///////////////////////////////////////////////////////////////////////////////
struct ProcessControl processdata[MAX_PROCESSDATA];

///////////////////////////////////////////////////////////////////////////////
// Functions
///////////////////////////////////////////////////////////////////////////////
struct ProcessControl *ProcessAllocate (void)
{
	for (int i = 0; i < MAX_PROCESSDATA; i++)
	{
		if (!processdata[i].inuse)
		{
			MemSet (&processdata[i], 0, sizeof (struct ProcessControl));
			MemSet (processdata[i].fnodes, -1, MAX_NODES);
			processdata[i].trc.pctrl = &processdata[i];
			processdata[i].inuse = 1;
			return &processdata[i];
		}
	}

	return 0;
}

void ProcessFree (struct ProcessControl *prc)
{
	prc->inuse = 0;
}

struct ProcessControl *ProcessFindByPid (int pid)
{
	for (int i = 0; i < MAX_PROCESSDATA; i++)
		if (processdata[i].inuse && processdata[i].pid == pid)
			return &processdata[i];

	return 0;
}
