/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

///////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////
#include "mem/mem.h"

///////////////////////////////////////////////////////////////////////////////
// Functions
///////////////////////////////////////////////////////////////////////////////
void PlatformTestMem (void)
{
	// Step 1
	unsigned int a = MemAlloc (1000, 0);
	Print ("Step 1: Address 0x%x\n", a);

	// Step 2
	unsigned int b = MemAlloc (1000, 0);
	Print ("Step 2: Address 0x%x\n", b);

	// Step 3
	struct MemMpuReturn mpu;
	unsigned int c = MemAllocMpu (7000, 0, &mpu);
	Print ("Step 3: Address 0x%x\n   dataptr 0x%x\n   rbar 0x%x\n   rasr 0x%x\n",
		c, mpu.dataptr, mpu.mpu_rbar, mpu.mpu_rasr);

	// Step 4
	MemFree (b);
	Print ("Step 4: Done\n");

	// Step 5
	unsigned int d = MemAllocMpu (512, 0, &mpu);
	Print ("Step 5: Address 0x%x\n   dataptr 0x%x\n   rbar 0x%x\n   rasr 0x%x\n",
		d, mpu.dataptr, mpu.mpu_rbar, mpu.mpu_rasr);

	// Step 6
	unsigned int e = MemAlloc (200, 0);
	Print ("Step 6: Address 0x%x\n", e);

	// Step 7
	MemFree (a);
	Print ("Step 7: Done\n");

	// Step 8
	MemFree (c);
	Print ("Step 8: Done\n");

	// Step 9
	MemFree (d);
	Print ("Step 9: Done\n");

	// Step 10
	MemFree (e);
	Print ("Step 10: Done\n");
}
