/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

///////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>

// File to convert
#include "img/lassie.c"

///////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////
int main (int argc, char **argv)
{
	int fd = open ("converted", O_RDWR | O_CREAT | O_TRUNC, S_IRUSR | S_IWUSR);

	if (fd >= 0)
	{
		int size = 320 * 240 * 2;

		if (write (fd, gimp_image.pixel_data, size) != size)
			printf ("Failed write: %s\n", strerror (errno));

		close (fd);
	}
	else
		printf ("Could not open file\n");
}
