/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

///////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>
#include <sys/ioctl.h>

///////////////////////////////////////////////////////////////////////////////
// Definitions
///////////////////////////////////////////////////////////////////////////////
typedef struct
{
	int datafd;
	int dcfd;
} lcd;

///////////////////////////////////////////////////////////////////////////////
// External functions
///////////////////////////////////////////////////////////////////////////////

// bus.c
int initbus (lcd *l);

int cslow (lcd *l);
int cshigh (lcd *l);

int writecommand (lcd *l, unsigned char command);
int writedata (lcd *l, unsigned char *data, int nbytes);

int writecommandarg0 (lcd *l, unsigned char cmd);
int writecommandarg1 (lcd *l, unsigned char cmd, unsigned char a1);
int writecommandarg2 (lcd *l, unsigned char cmd, unsigned char a1, unsigned char a2);
int writecommandarg3 (lcd *l, unsigned char cmd, unsigned char a1, unsigned char a2, unsigned char a3);
int writecommandarg4 (lcd *l, unsigned char cmd,
	unsigned char a1, unsigned char a2, unsigned char a3, unsigned char a4);
int writecommandarg5 (lcd *l, unsigned char cmd,
	unsigned char a1, unsigned char a2, unsigned char a3, unsigned char a4, unsigned char a5);

// st7735.c
int setaddress (lcd *l, int x1, int x2, int y1, int y2);
int initb (lcd *l);
int initr (lcd *l);

// main.c
void Delay (unsigned int time);
