/*
 * Copyright (C) 2018 Erlend Sveen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

///////////////////////////////////////////////////////////////////////////////
// Includes
///////////////////////////////////////////////////////////////////////////////
#include "lcdtest.h"

///////////////////////////////////////////////////////////////////////////////
// External functions
///////////////////////////////////////////////////////////////////////////////
/*
int setgamma (lcd *l)
{
	//unsigned char caset[] = {0xE0, 0x02, 0x1c, 0x07, 0x12, 0x37, 0x32, 0x29, 0x2d, 0x29, 0x25, 0x2B, 0x39, 0x00, 0x01, 0x03, 0x10};
	//unsigned char raset[] = {0xE1, 0x03, 0x1d, 0x07, 0x06, 0x2E, 0x2C, 0x29, 0x2D, 0x2E, 0x2E, 0x37, 0x3F, 0x00, 0x00, 0x02, 0x10};
	unsigned char caset[] = {0xE0, 0x09, 0x16, 0x09, 0x20, 0x21, 0x1B, 0x13, 0x19, 0x17, 0x15, 0x1E, 0x2B, 0x04, 0x05, 0x02, 0x0E};
	unsigned char raset[] = {0xE1, 0x0B, 0x14, 0x08, 0x1E, 0x22, 0x1D, 0x18, 0x1E, 0x1B, 0x1A, 0x24, 0x2B, 0x06, 0x06, 0x02, 0x0F};

	writedatacommand (l, 0, caset, 1);
	writedatacommand (l, 1, caset+1, sizeof(caset)-1);

	writedatacommand (l, 0, raset, 1);
	writedatacommand (l, 1, raset+1, sizeof(raset)-1);
	return 0;
}

void frmctr3 (lcd *l)
{
	unsigned char caset[] = {0xB3, 0x01, 0x2C, 0x2D, 0x01, 0x2C, 0x2D};

	writedatacommand (l, 0, caset, 1);
	writedatacommand (l, 1, caset+1, sizeof(caset)-1);
}*/

///////////////////////////////////////////////////////////////////////////////
// Functions
///////////////////////////////////////////////////////////////////////////////
int setaddress (lcd *l, int x1, int x2, int y1, int y2)
{
	unsigned char caset[] = {x1 >> 8, x1 >> 0, x2 >> 8, x2 >> 0};
	unsigned char raset[] = {y1 >> 8, y1 >> 0, y2 >> 8, y2 >> 0};

	cslow (l);
	writecommand (l, 0x2A);
	writedata (l, caset, sizeof(caset));
	cshigh (l);

	cslow (l);
	writecommand (l, 0x2B);
	writedata (l, raset, sizeof(raset));
	cshigh (l);

	return writecommandarg0 (l, 0x2C);
}
/*
int initb (lcd *l)
{
	writecommand (l, 0x01);						// SWRESET Software reset
	Delay (50);
	writecommand (l, 0x11);						// SLPOUT Exit sleep
	Delay (500);
	writecommandarg1 (l, 0x3A, 5);				// COLMOD Color mode 16-bit
	Delay (10);
	writecommandarg3 (l, 0xB1, 0, 0x06, 0x03);	// FRMCTR1 Frame rate control
	Delay (10);
	writecommandarg1 (l, 0x36, 0x08);			// MADCTL Memory access control
	writecommandarg2 (l, 0xB6, 0x15, 0x02); 	// DISSET5 Display settings
	writecommandarg1 (l, 0xB4, 0);				// INVCTR Inversion control
	writecommandarg2 (l, 0xC0, 0x02, 0x70);		// PWCTR1 Power control
	Delay (10);
	writecommandarg1 (l, 0xC1, 0x05);			// PWCTR2 Power control
	writecommandarg2 (l, 0xC2, 0x01, 0x02); 	// PWCTR3 Power control
	//writecommandarg2 (l, 0xC3, 0x8A, 0x2A); 	// PWCTR4 Power control
	//writecommandarg2 (l, 0xC4, 0x8A, 0xEE); 	// PWCTR5 Power control
	writecommandarg2 (l, 0xC5, 0x3C, 0x38); 	// VMCTR1 Power control
	Delay (10);
	//writecommand (l, 0x20);						// INVOFF
	writecommandarg2 (l, 0xFC, 0x11, 0x15); 	// PWCTR6 Power control
	setgamma (l);
	Delay (10);
	writecommand (l, 0x13); // NORON Normal display on
	Delay (50);
	writecommand (l, 0x29); // DISPON Display on
	Delay (120);
	setaddress (l, 0, 127, 0, 159);
	return 0;
}

int initr (lcd *l)
{
	writecommand (l, 0x01);						// SWRESET Software reset
	Delay (150);
	writecommand (l, 0x11);						// SLPOUT Exit sleep
	Delay (500);
	writecommandarg3 (l, 0xB1, 1, 0x2C, 0x2D);	// FRMCTR1 Frame rate control
	writecommandarg3 (l, 0xB2, 1, 0x2C, 0x2D);	// FRMCTR2 Frame rate control
	//writecommandarg3 (l, 0xB3, 1, 0x2C, 0x2D);	// FRMCTR3 Frame rate control
	frmctr3 (l);
	writecommandarg1 (l, 0xB4, 7);				// INVCTR Inversion control
	writecommandarg3 (l, 0xC0, 0xA2, 0x02, 0x84);// PWCTR1 Power control
	writecommandarg1 (l, 0xC1, 0xC5);			// PWCTR2 Power control
	writecommandarg2 (l, 0xC2, 0x0A, 0x00); 	// PWCTR3 Power control
	writecommandarg2 (l, 0xC3, 0x8A, 0x2A); 	// PWCTR4 Power control
	writecommandarg2 (l, 0xC4, 0x8A, 0xEE); 	// PWCTR5 Power control
	writecommandarg1 (l, 0xC5, 0x0E); 			// VMCTR1 Power control
	writecommand (l, 0x20);						// INVOFF
	//writecommandarg2 (l, 0xFC, 0x11, 0x15); 	// PWCTR6 Power control
	writecommandarg1 (l, 0x36, 0xC0);			// MADCTL Memory access control
	//writecommandarg2 (l, 0xB6, 0x15, 0x02); 	// DISSET5 Display settings
	writecommandarg1 (l, 0x3A, 5);				// COLMOD Color mode 16-bit
	setgamma (l);
	writecommand (l, 0x13); // NORON Normal display on
	Delay (50);
	writecommand (l, 0x29); // DISPON Display on
	Delay (120);
	setaddress (l, 0, 127, 0, 159);
	return 0;
}*/
