ENTRY(EntryPoint)

INCLUDE build/linkersections.ld

SECTIONS
{
	.text NOREL_BASE_TEXT :
	{
		*(.text)
		*(.text.*)
	}

	.rodata NOREL_BASE_RODATA :
	{
		*(.rodata)
		*(.rodata1)
		*(.rodata.*)

		PROVIDE_HIDDEN (__preinit_array_start = .);
		KEEP (*(.preinit_array*))
		PROVIDE_HIDDEN (__preinit_array_end = .);
		PROVIDE_HIDDEN (__init_array_start = .);
		KEEP (*(SORT(.init_array.*)))
		KEEP (*(.init_array*))
		PROVIDE_HIDDEN (__init_array_end = .);
	}

	.data NOREL_BASE_DATA :
	{
		*(.data)
		*(.data1)
		*(.data.*)
	}

	.bss NOREL_BASE_BSS :
	{
		*(.bss)
		*(.bss.*)
		*(.sbss)
		*(.sbss.*)
		*(COMMON)

		. = ALIGN(8);
		__end__ = .;
		PROVIDE ( end = . );
		PROVIDE(_heap_start = end );
		. = . + STACKSIZE;
		PROVIDE(_heap_end = .);
		. = ALIGN(8);
	}

	/DISCARD/ :
	{
		libc.a ( * )
		libm.a ( * )
		libgcc.a ( * )
	}
}
